zlib_compression.h
1 /*
2 ** ClanLib SDK
3 ** Copyright (c) 1997-2015 The ClanLib Team
4 **
5 ** This software is provided 'as-is', without any express or implied
6 ** warranty. In no event will the authors be held liable for any damages
7 ** arising from the use of this software.
8 **
9 ** Permission is granted to anyone to use this software for any purpose,
10 ** including commercial applications, and to alter it and redistribute it
11 ** freely, subject to the following restrictions:
12 **
13 ** 1. The origin of this software must not be misrepresented; you must not
14 ** claim that you wrote the original software. If you use this software
15 ** in a product, an acknowledgment in the product documentation would be
16 ** appreciated but is not required.
17 ** 2. Altered source versions must be plainly marked as such, and must not be
18 ** misrepresented as being the original software.
19 ** 3. This notice may not be removed or altered from any source distribution.
20 **
21 ** Note: Some of the libraries ClanLib may link to may have additional
22 ** requirements or restrictions.
23 **
24 ** File Author(s):
25 **
26 ** Magnus Norddahl
27 */
28
29
30 #pragma once
31
32 namespace clan
33 {
36
37 class DataBuffer;
38
40 class ZLibCompression
41 {
44 public:
45 enum CompressionMode
46 {
47 default_strategy,
48 filtered,
49 huffman_only,
50 rle,
51 fixed
52 };
53
54 // \brief Compress data
55 // \param data Data to compress
56 // \param raw Skips header if true
57 // \param compression_level Compression level in range 0-9. 0 = no compression, 1 = best speed, 6 = default, 9 = best compression.
58 // \param mode Compression strategy
59 static DataBuffer compress(const DataBuffer &data, bool raw = true, int compression_level = 6, CompressionMode mode = default_strategy);
60
61 // \brief Decompress data
62 // \param data Data to compress
63 // \param raw Skips header if true
64 static DataBuffer decompress(const DataBuffer &data, bool raw = true);
66 };
67
68 }
69
clan
Definition: clanapp.h:35
clan::ZLibCompression::default_strategy
Definition: zlib_compression.h:47
clan::ZLibCompression::fixed
Definition: zlib_compression.h:51
clan::ZLibCompression::CompressionMode
CompressionMode
Definition: zlib_compression.h:45
clan::ZLibCompression::rle
Definition: zlib_compression.h:50
clan::ZLibCompression::filtered
Definition: zlib_compression.h:48
clan::ZLibCompression
Deflate compressor.
Definition: zlib_compression.h:40
clan::ZLibCompression::compress
static DataBuffer compress(const DataBuffer &data, bool raw=true, int compression_level=6, CompressionMode mode=default_strategy)
clan::ZLibCompression::huffman_only
Definition: zlib_compression.h:49
clan::DataBuffer
General purpose data buffer.
Definition: databuffer.h:42
clan::ZLibCompression::decompress
static DataBuffer decompress(const DataBuffer &data, bool raw=true)